VTK: vtkFocalPlanePointPlacer Class Reference

| VTK 9.3.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkFocalPlanePointPlacer Class Reference

`#include <vtkFocalPlanePointPlacer.h>`

Inheritance diagram for vtkFocalPlanePointPlacer:
[legend]
Collaboration diagram for vtkFocalPlanePointPlacer:
[legend]

## Public Member Functions
int | ComputeWorldPosition (vtkRenderer *ren, double displayPos[2], double worldPos[3], double worldOrient[9]) override
| Given a renderer and a display position in pixel coordinates, compute the world position and orientation where this point will be placed. More...
int | ComputeWorldPosition (vtkRenderer *ren, double displayPos[2], double refWorldPos[3], double worldPos[3], double worldOrient[9]) override
| Given a renderer, a display position, and a reference world position, compute a new world position. More...
int | ValidateWorldPosition (double worldPos[3]) override
| Validate a world position. More...
int | ValidateWorldPosition (double worldPos[3], double worldOrient[9]) override
| Validate a world position. More...
virtual void | SetOffset (double)
| Optionally specify a signed offset from the focal plane for the points to be placed at. More...
virtual double | GetOffset ()
| Optionally specify a signed offset from the focal plane for the points to be placed at. More...
virtual void | SetPointBounds (double, double, double, double, double, double)
| Optionally Restrict the points to a set of bounds. More...
virtual void | SetPointBounds (double[6])
| Optionally Restrict the points to a set of bounds. More...
virtual double * | GetPointBounds ()
| Optionally Restrict the points to a set of bounds. More...
virtual void | GetPointBounds (double &, double &, double &, double &, double &, double &)
| Optionally Restrict the points to a set of bounds. More...
virtual void | GetPointBounds (double[6])
| Optionally Restrict the points to a set of bounds. More...
Public Member Functions inherited from vtkPointPlacer
virtual int | ValidateDisplayPosition (vtkRenderer *, double displayPos[2])
| Given a display position, check the validity of this position. More...
virtual int | UpdateWorldPosition (vtkRenderer *ren, double worldPos[3], double worldOrient[9])
| Given a current renderer, world position and orientation, update them according to the constraints of the placer. More...
virtual int | UpdateNodeWorldPosition (double worldPos[3], vtkIdType nodePointId)
| Give the placer a chance to update the node information, if any. More...
virtual int | UpdateInternalState ()
| Called by the representation to give the placer a chance to update itself. More...
virtual void | SetPixelTolerance (int)
| Set/get the tolerance used when performing computations in display coordinates. More...
virtual int | GetPixelTolerance ()
| Set/get the tolerance used when performing computations in display coordinates. More...
virtual void | SetWorldTolerance (double)
| Set/get the tolerance used when performing computations in world coordinates. More...
virtual double | GetWorldTolerance ()
| Set/get the tolerance used when performing computations in world coordinates. More...
vtkPointPlacer * | NewInstance () const
| Standard methods for instances of this class. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for instances of this class. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkFocalPlanePointPlacer * | New ()
| Instantiate this class. More...
Static Public Member Functions inherited from vtkPointPlacer
static vtkPointPlacer * | New ()
| Instantiate this class. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for instances of this class. More...
static vtkPointPlacer * | SafeDownCast (vtkObjectBase *o)
| Standard methods for instances of this class. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
| vtkFocalPlanePointPlacer ()
| ~vtkFocalPlanePointPlacer () override
void | GetCurrentOrientation (double worldOrient[9])
Protected Member Functions inherited from vtkPointPlacer
| vtkPointPlacer ()
| ~vtkPointPlacer () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
double | PointBounds [6]
double | Offset
Protected Attributes inherited from vtkPointPlacer
int | PixelTolerance
double | WorldTolerance
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
typedef vtkPointPlacer | Superclass
| Standard methods for instances of this class. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for instances of this class. More...
static vtkFocalPlanePointPlacer * | SafeDownCast (vtkObjectBase *o)
| Standard methods for instances of this class. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard methods for instances of this class. More...
vtkFocalPlanePointPlacer * | NewInstance () const
| Standard methods for instances of this class. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for instances of this class. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard methods for instances of this class. More...

## Additional Inherited Members
Public Types inherited from vtkPointPlacer
typedef vtkObject | Superclass
| Standard methods for instances of this class. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

Definition at line 17 of file vtkFocalPlanePointPlacer.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkPointPlacer vtkFocalPlanePointPlacer::Superclass

Standard methods for instances of this class.

Definition at line 29 of file vtkFocalPlanePointPlacer.h.

## Constructor & Destructor Documentation

## ◆ vtkFocalPlanePointPlacer()

vtkFocalPlanePointPlacer::vtkFocalPlanePointPlacer | ( |  | ) |
| protected

## ◆ ~vtkFocalPlanePointPlacer()

vtkFocalPlanePointPlacer::~vtkFocalPlanePointPlacer | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkFocalPlanePointPlacer* vtkFocalPlanePointPlacer::New | ( |  | ) |
| static

Instantiate this class.

## ◆ IsTypeOf()

static vtkTypeBool vtkFocalPlanePointPlacer::IsTypeOf | ( | const char * | type | ) |
| static

Standard methods for instances of this class.

## ◆ IsA()

virtual vtkTypeBool vtkFocalPlanePointPlacer::IsA | ( | const char * | type | ) |
| virtual

Standard methods for instances of this class.

Reimplemented from vtkPointPlacer.

## ◆ SafeDownCast()

static vtkFocalPlanePointPlacer* vtkFocalPlanePointPlacer::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard methods for instances of this class.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkFocalPlanePointPlacer::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard methods for instances of this class.

Reimplemented from vtkPointPlacer.

## ◆ NewInstance()

vtkFocalPlanePointPlacer* vtkFocalPlanePointPlacer::NewInstance | ( |  | ) | const

Standard methods for instances of this class.

## ◆ PrintSelf()

void vtkFocalPlanePointPlacer::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard methods for instances of this class.

Reimplemented from vtkObject.

## ◆ ComputeWorldPosition() [1/2]

int vtkFocalPlanePointPlacer::ComputeWorldPosition | ( | vtkRenderer * | ren,
|  | double | displayPos[2],
|  | double | worldPos[3],
|  | double | worldOrient[9]
| ) |  |
| overridevirtual

Given a renderer and a display position in pixel coordinates, compute the world position and orientation where this point will be placed.

This method is typically used by the representation to place the point initially. A return value of 1 indicates that constraints of the placer are met.

Reimplemented from vtkPointPlacer.

## ◆ ComputeWorldPosition() [2/2]

int vtkFocalPlanePointPlacer::ComputeWorldPosition | ( | vtkRenderer * | ren,
|  | double | displayPos[2],
|  | double | refWorldPos[3],
|  | double | worldPos[3],
|  | double | worldOrient[9]
| ) |  |
| overridevirtual

Given a renderer, a display position, and a reference world position, compute a new world position.

The orientation will be the standard coordinate axes, and the computed world position will be created by projecting the display point onto a plane that is parallel to the focal plane and runs through the reference world position. This method is typically used to move existing points.

Reimplemented from vtkPointPlacer.

## ◆ ValidateWorldPosition() [1/2]

int vtkFocalPlanePointPlacer::ValidateWorldPosition | ( | double | worldPos[3] | ) |
| overridevirtual

Validate a world position.

All world positions are valid so these methods always return 1.

Reimplemented from vtkPointPlacer.

## ◆ ValidateWorldPosition() [2/2]

int vtkFocalPlanePointPlacer::ValidateWorldPosition | ( | double | worldPos[3],
|  | double | worldOrient[9]
| ) |  |
| overridevirtual

Validate a world position.

All world positions are valid so these methods always return 1.

Reimplemented from vtkPointPlacer.

## ◆ SetOffset()

virtual void vtkFocalPlanePointPlacer::SetOffset | ( | double |  | ) |
| virtual

Optionally specify a signed offset from the focal plane for the points to be placed at.

If negative, the constraint plane is offset closer to the camera. If positive, its further away from the camera.

## ◆ GetOffset()

virtual double vtkFocalPlanePointPlacer::GetOffset | ( |  | ) |
| virtual

Optionally specify a signed offset from the focal plane for the points to be placed at.

If negative, the constraint plane is offset closer to the camera. If positive, its further away from the camera.

## ◆ SetPointBounds() [1/2]

virtual void vtkFocalPlanePointPlacer::SetPointBounds | ( | double | ,
|  | double | ,
|  | double | ,
|  | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Optionally Restrict the points to a set of bounds.

The placer will invalidate points outside these bounds.

## ◆ SetPointBounds() [2/2]

virtual void vtkFocalPlanePointPlacer::SetPointBounds | ( | double | [6] | ) |
| virtual

Optionally Restrict the points to a set of bounds.

The placer will invalidate points outside these bounds.

## ◆ GetPointBounds() [1/3]

virtual double* vtkFocalPlanePointPlacer::GetPointBounds | ( |  | ) |
| virtual

Optionally Restrict the points to a set of bounds.

The placer will invalidate points outside these bounds.

## ◆ GetPointBounds() [2/3]

virtual void vtkFocalPlanePointPlacer::GetPointBounds | ( | double & | ,
|  | double & | ,
|  | double & | ,
|  | double & | ,
|  | double & | ,
|  | double & |
| ) |  |
| virtual

Optionally Restrict the points to a set of bounds.

The placer will invalidate points outside these bounds.

## ◆ GetPointBounds() [3/3]

virtual void vtkFocalPlanePointPlacer::GetPointBounds | ( | double | [6] | ) |
| virtual

Optionally Restrict the points to a set of bounds.

The placer will invalidate points outside these bounds.

## ◆ GetCurrentOrientation()

void vtkFocalPlanePointPlacer::GetCurrentOrientation | ( | double | worldOrient[9] | ) |
| protected

## Member Data Documentation

## ◆ PointBounds

double vtkFocalPlanePointPlacer::PointBounds[6]
| protected

Definition at line 91 of file vtkFocalPlanePointPlacer.h.

## ◆ Offset

double vtkFocalPlanePointPlacer::Offset
| protected

Definition at line 92 of file vtkFocalPlanePointPlacer.h.

The documentation for this class was generated from the following file:

- Interaction/Widgets/vtkFocalPlanePointPlacer.h